#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

vector<vector<int>> g;
int n, k, t;
vector<int> dists;
vector<bool> vis;

void bfs(int start) {
    dists.resize(n, 1000000);
    vis.resize(n);
    dists[start] = 0;
    vis[start] = 1;
    queue<int> q;
    q.push(start);
    while (q.size()) {
        int v = q.front();
        q.pop();
        for (int u : g[v]) {
            if (!vis[u]) {
                int ndist = dists[v] + 1;
                if (ndist < dists[u]) {
                    dists[u] = ndist;
                }
                vis[u] = 1;
                q.push(u);            }
        }
    }
}

int main()
{
    cin >> n >> k >> t;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v; cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    bfs(0);
    sort(dists.begin(), dists.end());
    for (int i = n - 1; i >= 0; i++) {
        if (k > 0) {
            dists[i] = 1;
            k--;
        }
        else {
            break;
        }
    }
    int mxn = 0;
    for (int i : dists) {
        if (mxn < i) {
            mxn = i;
        }
    }
    cout << mxn;
}
